{
  description = "Projet de semantique de L3";

  inputs = {
    flake-utils.url = "github:numtide/flake-utils";
    nixpkgs.url = "github:nixos/nixpkgs/nixos-unstable";
  };

  outputs = { self, nixpkgs, flake-utils }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = import nixpkgs {
          config = { allowUnfree = true; };
          inherit system;
        };
        ocamlLibs = with pkgs.ocamlPackages; [
          camlidl
          apron
          findlib
          zarith
          menhir
          menhirLib
          odoc
          utop
          ocamlformat_0_26_0
        ];
      in
      {
        devShell = pkgs.mkShell {
          buildInputs = with pkgs; [
            mpfr
            gnumake
            dune_3
            ocaml
            graphviz
          ] ++ ocamlLibs;
        };
      });
}
